## kid3 3.1

=== CMakeLists.txt ===
# Build Kid3 using CMake
#
# Linux:
# cmake -D CMAKE_BUILD_TYPE=Release -D WITH_APPS=Qt -D CMAKE_INSTALL_PREFIX=/usr ../kid3
# make
# make install/strip DESTDIR=$(pwd)/inst # or
# cpack
#
# Windows:
# set INCLUDE=%MSYSDIR%\local\include
# set LIB=%MSYSDIR%\local\lib
# cmake -G "MinGW Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= ..\kid3
# mingw32-make
# cpack
#
# Mac OS X:
# cmake -G "Unix Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= ../kid3
# make
# cpack

project(kid3)

cmake_minimum_required(VERSION 2.8)

set(BUILD_SHARED_LIBS ON CACHE BOOL "build shared libraries")
set(WITH_QT4 OFF CACHE BOOL "force use of Qt4")
set(WITH_QT5 OFF CACHE BOOL "force use of Qt5")
set(WITH_TAGLIB ON CACHE BOOL "build with TagLib")
set(WITH_MP4V2 OFF CACHE BOOL "build with mp4v2")
set(WITH_ID3LIB ON CACHE BOOL "build with id3lib")
set(WITH_VORBIS ON CACHE BOOL "build with Ogg/Vorbis")
set(WITH_FLAC ON CACHE BOOL "build with FLAC")
set(WITH_CHROMAPRINT ON CACHE BOOL "build with Chromaprint")
set(WITH_FFMPEG OFF CACHE BOOL "force use of FFmpeg for Chromaprint decoding")
set(WITH_CHROMAPRINT_FFMPEG OFF CACHE BOOL "link FFmpeg only for Chromaprint FFT")
set(WITH_GSTREAMER OFF CACHE BOOL "force use of GStreamer for Chromaprint decoding")
set(WITH_QAUDIODECODER OFF CACHE BOOL "force use of QAudioDecoder for Chromaprint decoding")
set(WITH_PHONON ON CACHE BOOL "build with Phonon")
set(WITH_GCC_PCH OFF CACHE BOOL "enable precompiled headers")
if (APPLE OR WIN32)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI" CACHE STRING "build applications (Qt;CLI;Test)")
else (APPLE OR WIN32)
  set(WITH_DBUS ON CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI;KDE" CACHE STRING "build applications (Qt;CLI;KDE;Test)")
endif (APPLE OR WIN32)
if (WIN32)
  set(WITH_READLINE OFF CACHE BOOL "build with readline")
else (WIN32)
  set(WITH_READLINE ON CACHE BOOL "build with readline")
endif (WIN32)

if (DEFINED WITH_KDE)
  unset(WITH_KDE CACHE)
  message(FATAL_ERROR "The variable WITH_KDE is no longer used. The KDE and Qt "
                      "applications can now be built together using common "
                      "libraries. Use WITH_APPS with a value of \"KDE\" for "
                      "the KDE application, \"Qt\" for the Qt application, "
                      "\"CLI\" for the command line application or "
                      "\"Qt;CLI;KDE\" for all. Default is -DWITH_APPS="
                      "\"${WITH_APPS}\".")
endif (DEFINED WITH_KDE)

if (WITH_APPS)
  string(TOLOWER "${WITH_APPS}" _apps_lower)
  foreach (_app ${_apps_lower})
    if (_app STREQUAL "qt")
      set(BUILD_QT_APP ON)
    elseif (_app STREQUAL "cli")
      set(BUILD_CLI_APP ON)
    elseif (_app STREQUAL "kde")
      set(BUILD_KDE_APP ON)
    elseif (_app STREQUAL "test")
      set(BUILD_TEST_APP ON)
    else ()
      message(SEND_ERROR "Invalid value ${_app} in WITH_APPS. "
                         "Supported applications are \"Qt;KDE;Test\".")
    endif ()
  endforeach ()
endif (WITH_APPS)

# Version information
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 1)
set(CPACK_PACKAGE_VERSION_PATCH 0)
set(KID3_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION ${KID3_VERSION})
#set(CPACK_PACKAGE_VERSION "git20140404")
set(RELEASE_YEAR 2014)

# Platform specific default installation paths
if (APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_DOCDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_TRANSLATIONSDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT "kid3.app/Contents/MacOS")
  set(WITH_PLUGINSDIR_DEFAULT "kid3.app/Contents/PlugIns")
elseif (WIN32)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ".")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT "./plugins")
else (APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "share")
  set(WITH_DOCDIR_DEFAULT "share/doc/kid3-qt")
  if (BUILD_KDE_APP OR BUILD_SHARED_LIBS)
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3/translations")
  else (BUILD_KDE_APP OR BUILD_SHARED_LIBS)
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3-qt/translations")
  endif (BUILD_KDE_APP OR BUILD_SHARED_LIBS)
  set(WITH_BINDIR_DEFAULT "bin")
  set(WITH_LIBDIR_DEFAULT "lib${LIB_SUFFIX}/kid3")
  set(WITH_PLUGINSDIR_DEFAULT "${WITH_LIBDIR_DEFAULT}/plugins")
endif (APPLE)

set(WITH_DATAROOTDIR ${WITH_DATAROOTDIR_DEFAULT} CACHE STRING
    "data root directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_DOCDIR ${WITH_DOCDIR_DEFAULT} CACHE STRING
    "documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_TRANSLATIONSDIR ${WITH_TRANSLATIONSDIR_DEFAULT} CACHE STRING
    "translations directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_BINDIR ${WITH_BINDIR_DEFAULT} CACHE STRING
    "binary directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_LIBDIR ${WITH_LIBDIR_DEFAULT} CACHE STRING
    "library directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_PLUGINSDIR ${WITH_PLUGINSDIR_DEFAULT} CACHE STRING
    "plugin directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_MANDIR ${WITH_DATAROOTDIR}/man CACHE STRING
    "man documentation directory relative to CMAKE_INSTALL_PREFIX")
if (CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "${CMAKE_INSTALL_PREFIX}/")
else (CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "")
endif (CMAKE_INSTALL_PREFIX)

if (APPLE)
file(RELATIVE_PATH CFG_DATAROOTDIR "/kid3.app/Contents/MacOS" /${WITH_DATAROOTDIR})
file(RELATIVE_PATH CFG_DOCDIR "/kid3.app/Contents/MacOS" /${WITH_DOCDIR})
file(RELATIVE_PATH CFG_TRANSLATIONSDIR "/kid3.app/Contents/MacOS" /${WITH_TRANSLATIONSDIR})
file(RELATIVE_PATH CFG_PLUGINSDIR "/kid3.app/Contents/MacOS" /${WITH_PLUGINSDIR})
else (APPLE)
set(CFG_DATAROOTDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DATAROOTDIR})
set(CFG_DOCDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DOCDIR})
set(CFG_TRANSLATIONSDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_TRANSLATIONSDIR})
file(RELATIVE_PATH CFG_PLUGINSDIR /${WITH_BINDIR} /${WITH_PLUGINSDIR})
endif (APPLE)

find_package(Threads)
find_package(Perl REQUIRED)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

# Find Qt
set(_qt5Dir)
set(QT_EXECUTABLE_COMPILE_FLAGS)
if (NOT WITH_QT4)
  string(REGEX MATCH "^(.*[Qq]t5.*).bin.qmake.*" _qt5Dir "${QT_QMAKE_EXECUTABLE}")
  if (_qt5Dir)
    set(_qt5Dir ${CMAKE_MATCH_1})
  endif (_qt5Dir)
endif (NOT WITH_QT4)

if (NOT WITH_QT5 AND NOT _qt5Dir)
  set(_QT4_COMPONENTS QtCore QtGui QtNetwork QtXml)
  if (WIN32)
    set(QT_USE_QTMAIN TRUE)
  endif (WIN32)
  set(QT_USE_QTDBUS ${WITH_DBUS})
  find_package(Qt4 COMPONENTS ${_QT4_COMPONENTS})
  if (Qt4_FOUND OR QT4_FOUND)
    include (${QT_USE_FILE})
    if (NOT WITH_QT4)
      message(STATUS "Qt4 found, explicitly set WITH_QT5 or QT_QMAKE_EXECUTABLE to use a different version.")
    endif (NOT WITH_QT4)
  endif (Qt4_FOUND OR QT4_FOUND)
endif (NOT WITH_QT5 AND NOT _qt5Dir)

if (NOT WITH_QT4 AND NOT Qt4_FOUND AND NOT QT4_FOUND)
  if (_qt5Dir)
    set(Qt5Core_DIR "${_qt5Dir}/lib/cmake/Qt5Core")
    find_package(Qt5Core)
    if (Qt5Core_FOUND)
      message(STATUS "Qt5Core found in ${_qt5Dir}")
      set(Qt5Gui_DIR "${_qt5Dir}/lib/cmake/Qt5Gui")
      set(Qt5Widgets_DIR "${_qt5Dir}/lib/cmake/Qt5Widgets")
      set(Qt5Network_DIR "${_qt5Dir}/lib/cmake/Qt5Network")
      set(Qt5Xml_DIR "${_qt5Dir}/lib/cmake/Qt5Xml")
      set(Qt5Multimedia_DIR "${_qt5Dir}/lib/cmake/Qt5Multimedia")
      set(Qt5LinguistTools_DIR "${_qt5Dir}/lib/cmake/Qt5LinguistTools")
      set(Qt5Test_DIR "${_qt5Dir}/lib/cmake/Qt5Test")
      if (WITH_DBUS)
        set(Qt5DBus_DIR "${_qt5Dir}/lib/cmake/Qt5DBus")
      endif (WITH_DBUS)
    endif (Qt5Core_FOUND)
  else (_qt5Dir)
    find_package(Qt5Core)
  endif (_qt5Dir)
  if (Qt5Core_FOUND)
    set(HAVE_QT5 1)
    set(WITH_PHONON OFF)
    set(QT_INCLUDES)
    set(QT_DEFINITIONS)
    set(QT_LIBRARIES)
    set(_qt5Components Core Gui Widgets Network Xml Multimedia LinguistTools Test)
    if (WITH_DBUS)
      set(_qt5Components ${_qt5Components} DBus)
    endif (WITH_DBUS)
    foreach (_qt5Component ${_qt5Components})
      find_package("Qt5${_qt5Component}")
      if (Qt5${_qt5Component}_FOUND)
        set(QT_INCLUDES ${QT_INCLUDES} ${Qt5${_qt5Component}_INCLUDE_DIRS})
        set(QT_DEFINITIONS ${QT_DEFINITIONS} ${Qt5${_qt5Component}_DEFINITIONS})
        set(QT_LIBRARIES ${QT_LIBRARIES} ${Qt5${_qt5Component}_LIBRARIES})
      endif (Qt5${_qt5Component}_FOUND)
    endforeach ()
    if (Qt5DBus_FOUND)
      set(HAVE_QTDBUS 1)
    endif (Qt5DBus_FOUND)
    set(QT_EXECUTABLE_COMPILE_FLAGS ${Qt5Core_EXECUTABLE_COMPILE_FLAGS})
    get_target_property(QT_LIBRARY_DIR Qt5::Core LOCATION)
    get_filename_component(QT_LIBRARY_DIR ${QT_LIBRARY_DIR} PATH)
    get_target_property(QT_LUPDATE_EXECUTABLE Qt5::lupdate LOCATION)
    get_target_property(QT_PLUGINS_DIR Qt5::QJpegPlugin LOCATION)
    if (QT_PLUGINS_DIR)
      get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
      get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
    elseif (_qt5Dir)
      set(QT_PLUGINS_DIR ${_qt5Dir}/plugins)
    else (QT_PLUGINS_DIR)
      # Before Qt 5.2, there seems to be no way to get the plugins directory.
      # Assume it is on the same level as the bin directory.
      get_filename_component(QT_PLUGINS_DIR ${QT_LUPDATE_EXECUTABLE} PATH)
      get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
      set(QT_PLUGINS_DIR ${QT_PLUGINS_DIR}/plugins)
    endif (QT_PLUGINS_DIR)

    macro(qt4_add_translation)
      qt5_add_translation(${ARGV})
    endmacro(qt4_add_translation)

    macro(qt4_wrap_cpp)
      qt5_wrap_cpp(${ARGV})
    endmacro(qt4_wrap_cpp)

    macro(qt4_add_resources)
      qt5_add_resources(${ARGV})
    endmacro(qt4_add_resources)

    get_target_property(_qmakeLocation Qt5::qmake LOCATION)
    message(STATUS "Found Qt-Version ${Qt5Core_VERSION_STRING} (using ${_qmakeLocation})")
  endif (Qt5Core_FOUND)
endif (NOT WITH_QT4 AND NOT Qt4_FOUND AND NOT QT4_FOUND)

if (NOT Qt4_FOUND AND NOT QT4_FOUND AND NOT Qt5Core_FOUND)
  message(FATAL_ERROR "Neither Qt4 nor Qt5 found.")
endif (NOT Qt4_FOUND AND NOT QT4_FOUND AND NOT Qt5Core_FOUND)


# Check that QT_NO_DEBUG is defined for release configurations
foreach (_buildType RELWITHDEBINFO RELEASE MINSIZEREL)
  if (NOT CMAKE_CXX_FLAGS_${_buildType} MATCHES "-DQT_NO_DEBUG")
    set(CMAKE_CXX_FLAGS_${_buildType} "${CMAKE_CXX_FLAGS_${_buildType}} -DQT_NO_DEBUG")
  endif ()
endforeach ()

### Check for xsltproc
find_program(XSLTPROC xsltproc DOC "xsltproc transforms XML via XSLT"
  PATHS $ENV{XSLTPROCDIR})
if (NOT XSLTPROC)
  message(FATAL_ERROR "Could not find xsltproc")
endif (NOT XSLTPROC)

### Check for HTML docbook.xsl
file(GLOB _versionedStyleSheetDir /usr/share/xml/docbook/xsl-stylesheets-*)
find_path(DOCBOOK_XSL_DIR html/docbook.xsl
  PATHS ${WITH_DOCBOOKDIR}
        /usr/share/xml/docbook/stylesheet/nwalsh
        /usr/share/xml/docbook/stylesheet/nwalsh/current
        /usr/share/xml/docbook/stylesheet/docbook-xsl
        /usr/share/xml/docbook/stylesheet/docbook-xsl-ns
        /usr/share/sgml/docbook/xsl-stylesheets
        /usr/share/apps/ksgmltools2/docbook/xsl
       ${_versionedStyleSheetDir}
       $ENV{DOCBOOKDIR}
       $ENV{HOME}/docbook-xsl-1.72.0
  NO_DEFAULT_PATH)
if (NOT DOCBOOK_XSL_DIR)
  message(FATAL_ERROR "Could not find HTML docbook.xsl")
endif (NOT DOCBOOK_XSL_DIR)

set(BASIC_LIBRARIES ${QT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})


if (APPLE)
  set(BASIC_LIBRARIES ${BASIC_LIBRARIES} "-framework CoreServices")
endif (APPLE)

if (WIN32)
  link_directories($ENV{LIB})
endif (WIN32)

if (BUILD_SHARED_LIBS)
  add_definitions(-DKID3_SHARED)

  # the RPATH to be used when installing, but only if it's not a system directory
  # see http://www.cmake.org/Wiki/CMake_RPATH_handling

=== src/app/kde/CMakeLists.txt ===
set(kde_SRCS
  mainkde.cpp
  kdeplatformtools.cpp
  kdemainwindow.cpp
  kdeconfigdialog.cpp
  kdesettings.cpp
)

add_definitions(${KDE4_DEFINITIONS} -DKDE_NO_COMPAT ${KDE4_ENABLE_EXCEPTIONS})
include_directories(${KDE4_INCLUDES})

kde4_add_executable(kid3 ${kde_SRCS})

target_link_libraries(kid3 kid3-gui ${KDE4_KDEUI_LIBS} ${KDE4_KIO_LIBS} -lstdc++)

install(TARGETS kid3 DESTINATION ${BIN_INSTALL_DIR})
install(FILES ../kid3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES kid3ui.rc DESTINATION ${DATA_INSTALL_DIR}/kid3)

=== src/app/qt/CMakeLists.txt ===
set(qt_SRCS
  mainqt.cpp
  platformtools.cpp
  kid3mainwindow.cpp
  recentfilesmenu.cpp
  browserdialog.cpp
  messagedialog.cpp
  configdialog.cpp
  mainwindowconfig.cpp
  shortcutsmodel.cpp
  shortcutsdelegate.cpp
)
set(qt_MOC_HDRS
  kid3mainwindow.h
  recentfilesmenu.h
  browserdialog.h
  messagedialog.h
  configdialog.h
  shortcutsmodel.h
  shortcutsdelegate.h
)
qt4_wrap_cpp(qt_GEN_MOC_SRCS ${qt_MOC_HDRS})
set(qt_SRCS ${qt_SRCS} ${qt_GEN_MOC_SRCS})

if (APPLE)
  # Icon and properties for .plist file
  set(MACOSX_BUNDLE_BUNDLE_NAME "Kid3")
  set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
  set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
  set_source_files_properties(kid3.icns
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  set(qt_SRCS ${qt_SRCS} kid3.icns)
  set_source_files_properties(qt.conf
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  set(qt_SRCS ${qt_SRCS} qt.conf)
elseif (WIN32)
  if (MINGW)
    # support for Windows resource files with MinGW
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
      "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  endif (MINGW)
  # add Windows resource file with icon
  set(qt_SRCS ${qt_SRCS} kid3win.rc)
endif (APPLE)

if (UNIX AND NOT APPLE)
  find_program(GZIP_PROGRAM gzip)
  # install desktop file and icons for Linux
  add_custom_command(OUTPUT kid3-qt.desktop
    COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.pl
      <${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop >kid3-qt.desktop
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop
  )
  add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
    DESTINATION "${WITH_DATAROOTDIR}/applications")
  if (GZIP_PROGRAM)
    add_custom_command(OUTPUT kid3-qt.svg
      COMMAND ${GZIP_PROGRAM} -cd ${CMAKE_CURRENT_SOURCE_DIR}/../hisc-app-kid3.svgz >kid3-qt.svg
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../hisc-app-kid3.svgz
    )
    set(qt_SRCS ${qt_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps")
  else (GZIP_PROGRAM)
    install(FILES ../hisc-app-kid3.svgz
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
            RENAME kid3-qt.svgz)
  endif (GZIP_PROGRAM)
  install(FILES ../hi128-app-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/128x128/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi64-app-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/64x64/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi48-app-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi32-app-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/32x32/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi16-app-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/16x16/apps"
          RENAME kid3-qt.png)
elseif (APPLE)
  install(FILES ../hi48-app-kid3.png
          DESTINATION ${WITH_DATAROOTDIR}
          RENAME kid3.png)
endif (UNIX AND NOT APPLE)

add_definitions(${QT_DEFINITIONS} ${QT_EXECUTABLE_COMPILE_FLAGS})
set(qt_RESOURCES kid3.qrc)
qt4_add_resources(qt_GEN_RCS ${qt_RESOURCES})
add_executable(${KID3_EXECUTABLE} MACOSX_BUNDLE WIN32
  ${qt_SRCS} ${qt_GEN_RCS})

target_link_libraries(${KID3_EXECUTABLE} kid3-gui -lstdc++)

if (APPLE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../../../macosx/Info.plist.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${KID3_EXECUTABLE} PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
endif (APPLE)

install(TARGETS ${KID3_EXECUTABLE}
  BUNDLE DESTINATION .
  RUNTIME DESTINATION ${WITH_BINDIR})

if (APPLE OR WIN32)

  # Put Qt libraries and plugins into installation package to create a
  # standalone bundle on Mac OS X and Windows
  set(plugin_dest_dir ${WITH_BINDIR})
  set(bundle_app
   "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/${KID3_EXECUTABLE}")
  if (APPLE)
    set(plugin_dest_dir kid3.app/Contents/PlugIns)
    set(bundle_app "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app")
  endif (APPLE)
  if (WIN32)
    set(bundle_app
      "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/kid3.exe")
  endif (WIN32)
  string(REPLACE "/./" "/" bundle_app ${bundle_app})

  # Install Qt JPEG and Phonon plugins
  install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
    DESTINATION ${plugin_dest_dir}
    FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}")

  if (HAVE_QT5)
    if (APPLE)
      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
        DESTINATION kid3.app/Contents/MacOS
        FILES_MATCHING PATTERN "libqcocoa${CMAKE_SHARED_LIBRARY_SUFFIX}")
      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "libqavfmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
    elseif (WIN32)
      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "qwindows${CMAKE_SHARED_LIBRARY_SUFFIX}")
      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "dsengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif (APPLE)
  endif (HAVE_QT5)

  if (HAVE_PHONON)
    install(DIRECTORY "${QT_PLUGINS_DIR}/phonon_backend"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING
        PATTERN "*d4${CMAKE_SHARED_LIBRARY_SUFFIX}" EXCLUDE
        PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif (HAVE_PHONON)

  # Install and fix up all dependencies of the executable and the plugins.
  # On Mac OS X only keep the i386 code in the Qt libraries and plugins.
  install(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    if (APPLE)
      file(GLOB_RECURSE QTPLATFORMPLUGINS
        \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/MacOS/platforms/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
      set(QTPLUGINS \"\${QTPLUGINS};\${QTPLATFORMPLUGINS}\")
    endif (APPLE)
    file(GLOB_RECURSE KID3PLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_PLUGINSDIR}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    set(bundle_libs \"\${QTPLUGINS};\${KID3PLUGINS}\")
    if (APPLE AND BUILD_CLI_APP)
      set(bundle_libs \"\${bundle_libs};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_LIBDIR}/kid3-cli\")
    endif (APPLE AND BUILD_CLI_APP)
    fixup_bundle(\"${bundle_app}\" \"\${bundle_libs}\" \"${QT_LIBRARY_DIR}\")
    if (APPLE)
      file(GLOB_RECURSE _qtlibs \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/Frameworks/*Qt*\")
      file(GLOB_RECURSE _plugins \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/PlugIns/*.dylib\")
      foreach (_universalBinary \${_plugins} \${_qtlibs})
        execute_process(COMMAND lipo \${_universalBinary} -output \${_universalBinary} -thin i386)
      endforeach (_universalBinary \${plugins})
    endif (APPLE)
    ")

endif (APPLE OR WIN32)

if (WIN32)
  if (NOT HAVE_QT5)
    # Unfortunately, the binutils which come with the gcc-4.4.0 in the MinGW
    # for Qt generate an executable which cannot be analyzed with dumpbin.
    # This happens when Kid3 is linked with libav (used with Chromaprint).
    # Therefore, the dependencies for kid3.exe are not added to the bundle.
    # This workaround adds the missing files.
    install(FILES "${QT_BINARY_DIR}/QtNetwork4.dll"
                  "${QT_BINARY_DIR}/QtXml4.dll"
            DESTINATION ${WITH_BINDIR})
  else (NOT HAVE_QT5)
    if (EXISTS "${_qt5Dir}/../ported-x32/bin/libjpeg-8.dll")
      install(FILES "${_qt5Dir}/../ported-x32/bin/libjpeg-8.dll"
              DESTINATION ${WITH_BINDIR})
    endif ()
    string(TOUPPER ${CMAKE_BUILD_TYPE} _build_type_uc)
    get_target_property(_qt5xml_location Qt5::Xml IMPORTED_LOCATION_${_build_type_uc})
    install(FILES ${_qt5xml_location}
            DESTINATION ${WITH_BINDIR})
  endif (NOT HAVE_QT5)
endif (WIN32)

=== src/plugins/taglibmetadata/CMakeLists.txt ===
set(TAGLIB_LIBRARIES)
set(TAGLIB_CFLAGS)
if(WITH_TAGLIB)
  if (WIN32)
    find_library(TAGLIB_LIBRARIES NAMES tag)
    find_path(TAGLIB_INCLUDE_DIR taglib/taglib.h)
    if (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
      set(TAGLIB_CFLAGS -I${TAGLIB_INCLUDE_DIR}/taglib -I${TAGLIB_INCLUDE_DIR} -DTAGLIB_STATIC)
      set(HAVE_TAGLIB 1)
      message(STATUS "TagLib found: ${TAGLIB_LIBRARIES}")
      set(TAGLIB_LIBRARIES ${TAGLIB_LIBRARIES} ${ZLIB_LIBRARIES})
    endif (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
  else (WIN32)
    find_program(TAGLIBCONFIG_EXECUTABLE NAMES taglib-config PATHS /usr/bin /usr/local/bin ${BIN_INSTALL_DIR})
    if(TAGLIBCONFIG_EXECUTABLE)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --libs RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_LIBRARIES)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --cflags RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_CFLAGS)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --version RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_VERSION)
      if(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
        if(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
          set(HAVE_TAGLIB 1)
          message(STATUS "TagLib found: ${TAGLIB_LIBRARIES}")
          set(TAGLIB_LIBRARIES ${TAGLIB_LIBRARIES} ${ZLIB_LIBRARIES} -lstdc++)
        endif(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
      endif(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
    endif(TAGLIBCONFIG_EXECUTABLE)
  endif (WIN32)
  if (NOT HAVE_TAGLIB)
    message(FATAL_ERROR "Could not find Taglib")
  endif (NOT HAVE_TAGLIB)
endif(WITH_TAGLIB)
if (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)
  set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${TAGLIB_LIBRARIES})
  set(_CMAKE_REQUIRED_DEFINITIONS_TMP ${CMAKE_REQUIRED_DEFINITIONS})
  set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} ${TAGLIB_CFLAGS})
  CHECK_CXX_SOURCE_COMPILES("#include <mpegfile.h>\nint main() {\n  TagLib::MPEG::File file(\"somefile.mp3\");\n  file.save(3, false, 3);\n  return 0;\n}\n" HAVE_TAGLIB_ID3V23_SUPPORT)
  CHECK_CXX_SOURCE_COMPILES("#include <mpegfile.h>\n#include <xmfile.h>\nint main() {\n  TagLib::MPEG::File file(\"somefile.mp3\");\n  return dynamic_cast<TagLib::XM::Properties*>(file.audioProperties()) != 0;\n}\n" HAVE_TAGLIB_XM_SUPPORT)
  set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
  set(CMAKE_REQUIRED_DEFINITIONS ${_CMAKE_REQUIRED_DEFINITIONS_TMP})


  configure_file(taglibconfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/taglibconfig.h)

  add_definitions(${TAGLIB_CFLAGS})
  include_directories(${CMAKE_CURRENT_BINARY_DIR} ../../core/tags)

  set(plugin_SRCS
    taglibmetadataplugin.cpp
    taglibfile.cpp
    taglibext/aac/aacfiletyperesolver.cpp
    taglibext/mp2/mp2filetyperesolver.cpp
    taglibext/synchronizedlyricsframe.cpp
    taglibext/eventtimingcodesframe.cpp
  )

  if (TAGLIB_VERSION STREQUAL "1.4")
    set(plugin_SRCS ${plugin_SRCS}
      taglibext/urllinkframe.cpp
      taglibext/unsynchronizedlyricsframe.cpp
      taglibext/generalencapsulatedobjectframe.cpp
      taglibext/speex/speexfile.cpp
      taglibext/speex/speexproperties.cpp
      taglibext/speex/taglib_speexfiletyperesolver.cpp
      taglibext/trueaudio/taglib_trueaudiofiletyperesolver.cpp
      taglibext/trueaudio/ttafile.cpp
      taglibext/trueaudio/ttaproperties.cpp
      taglibext/wavpack/taglib_wavpackfiletyperesolver.cpp
      taglibext/wavpack/wvfile.cpp
      taglibext/wavpack/wvproperties.cpp
    )
  endif (TAGLIB_VERSION STREQUAL "1.4")

  set(plugin_MOC_HDRS
    taglibmetadataplugin.h
  )

  set(plugin_NAME TaglibMetadata)

  if (WITH_GCC_PCH)
    add_definitions(${GCC_PCH_COMPILE_FLAGS})
  endif (WITH_GCC_PCH)

  string(TOLOWER ${plugin_NAME} plugin_TARGET)

  qt4_wrap_cpp(plugin_GEN_MOC_SRCS ${plugin_MOC_HDRS})

  add_library(${plugin_TARGET} ${plugin_SRCS} ${plugin_GEN_MOC_SRCS})
  target_link_libraries(${plugin_TARGET} kid3-core ${BASIC_LIBRARIES} ${TAGLIB_LIBRARIES})

  INSTALL_KID3_PLUGIN(${plugin_TARGET} ${plugin_NAME})
endif (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)

=== debian/changelog ===
kid3 (3.1-1build2) utopic; urgency=medium

  * Rebuild against libav11.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 04 Sep 2014 22:08:28 +0100

kid3 (3.1-1build1) utopic; urgency=medium

  * Rebuild against libav10.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 22 Jun 2014 18:48:55 +0100

kid3 (3.1-1) unstable; urgency=medium

  * New upstream release.
    - Drop merged patch 01-desktop-keywords.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 05 May 2014 10:39:24 +0200

## kid3 3.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,7 @@
 set(WITH_QAUDIODECODER OFF CACHE BOOL "force use of QAudioDecoder for Chromaprint decoding")
 set(WITH_PHONON ON CACHE BOOL "build with Phonon")
 set(WITH_GCC_PCH OFF CACHE BOOL "enable precompiled headers")
+set(WITH_NO_MANCOMPRESS OFF CACHE BOOL "disable compressed manpages")
 if (APPLE OR WIN32)
   set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
   set(WITH_APPS "Qt;CLI" CACHE STRING "build applications (Qt;CLI;Test)")
@@ -82,10 +83,10 @@
 # Version information
 set(CPACK_PACKAGE_VERSION_MAJOR 3)
 set(CPACK_PACKAGE_VERSION_MINOR 1)
-set(CPACK_PACKAGE_VERSION_PATCH 0)
+set(CPACK_PACKAGE_VERSION_PATCH 1)
 set(KID3_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 set(CPACK_PACKAGE_VERSION ${KID3_VERSION})
-#set(CPACK_PACKAGE_VERSION "git20140404")
+#set(CPACK_PACKAGE_VERSION "git20140817")
 set(RELEASE_YEAR 2014)
 
 # Platform specific default installation paths
@@ -307,4 +308,3 @@
   add_definitions(-DKID3_SHARED)
 
   # the RPATH to be used when installing, but only if it's not a system directory
-  # see http://www.cmake.org/Wiki/CMake_RPATH_handling

=== doc/CMakeLists.txt ===
# Create HTML handbook from DocBook file in language directory
macro (kid3_create_handbook _docbook)
  get_filename_component(_input ${_docbook} ABSOLUTE)
  get_filename_component(_lang ${CMAKE_CURRENT_SOURCE_DIR} NAME)
  set(_output ${CMAKE_CURRENT_BINARY_DIR}/kid3_${_lang}.html)
  set(_fixdocbook_pl ${CMAKE_CURRENT_SOURCE_DIR}/../fixdocbook.pl)
  set(_fixhtml_pl ${CMAKE_CURRENT_SOURCE_DIR}/../fixhtml.pl)
  set(_docbook_xsl ${DOCBOOK_XSL_DIR}/html/docbook.xsl)
  if (WIN32)
    # The expressions in pipes do not work for Windows,
    # so temporary files are used.
    set(_tmp_xml ${CMAKE_CURRENT_BINARY_DIR}/tmp.xml)
    set(_tmp_html ${CMAKE_CURRENT_BINARY_DIR}/tmp.html)
    add_custom_command(OUTPUT ${_tmp_xml}
      COMMAND ${PERL_EXECUTABLE} ${_fixdocbook_pl} <${_input} >${_tmp_xml}
      DEPENDS ${_input}
    )
    add_custom_command(OUTPUT ${_tmp_html}
      COMMAND ${XSLTPROC} --novalid --nonet ${_docbook_xsl} ${_tmp_xml} >${_tmp_html}
      DEPENDS ${_tmp_xml}
    )
    add_custom_command(OUTPUT ${_output}
      COMMAND ${PERL_EXECUTABLE} -n ${_fixhtml_pl} <${_tmp_html} >${_output}
      DEPENDS ${_tmp_html}
    )
  else (WIN32)
    add_custom_command(OUTPUT ${_output}
      COMMAND
        ${PERL_EXECUTABLE} ${_fixdocbook_pl} <${_input} |
        ${XSLTPROC} --novalid --nonet ${_docbook_xsl} - |
        ${PERL_EXECUTABLE} -n ${_fixhtml_pl} >${_output}
      DEPENDS ${_input}
    )
  endif (WIN32)
  add_custom_target("${_lang}-html-handbook" ALL DEPENDS ${_output})
  install(FILES ${_output} DESTINATION ${WITH_DOCDIR})
endmacro (kid3_create_handbook)

if (UNIX)
  if (NOT WITH_NO_MANCOMPRESS)
    find_program(GZIP_EXECUTABLE gzip)
  endif (NOT WITH_NO_MANCOMPRESS)

  # Create man page from DocBook file in language directory
  macro (kid3_create_manpage _docbook)
    get_filename_component(_input ${_docbook} ABSOLUTE)
    get_filename_component(_lang ${CMAKE_CURRENT_SOURCE_DIR} NAME)
    set(_output ${CMAKE_CURRENT_BINARY_DIR}/kid3.1)
    set(_fixdocbook_pl ${CMAKE_CURRENT_SOURCE_DIR}/../fixmandocbook.pl)
    set(_docbook_xsl ${DOCBOOK_XSL_DIR}/manpages/docbook.xsl)
    add_custom_command(OUTPUT ${_output}
      COMMAND
        ${PERL_EXECUTABLE} ${_fixdocbook_pl} <${_input} |
        ${XSLTPROC} --novalid --nonet ${_docbook_xsl} -
      DEPENDS ${_input}
    )
    if (WITH_NO_MANCOMPRESS)
      set(_gzExt "")
      set(_output_gz ${_output})
    else (WITH_NO_MANCOMPRESS)
      set(_gzExt ".gz")
      set(_output_gz ${_output}${_gzExt})
      add_custom_command(OUTPUT ${_output_gz}
        COMMAND ${GZIP_EXECUTABLE} -c ${_output} >${_output_gz}
        DEPENDS ${_output}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      )
    endif (WITH_NO_MANCOMPRESS)
    add_custom_target("${_lang}-man-handbook" ALL DEPENDS ${_output_gz})
    if (_lang STREQUAL "en")
      set(_install_dir ${WITH_MANDIR}/man1)
    else (_lang STREQUAL "en")
      set(_install_dir ${WITH_MANDIR}/${_lang}/man1)
    endif (_lang STREQUAL "en")
    install(FILES ${_output_gz} DESTINATION ${_install_dir})
    if (BUILD_QT_APP)
      install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink kid3.1${_gzExt} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_install_dir}/kid3-qt.1${_gzExt}\")")
    endif (BUILD_QT_APP)
    if (BUILD_CLI_APP)
      install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink kid3.1${_gzExt} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_install_dir}/kid3-cli.1${_gzExt}\")")
    endif (BUILD_CLI_APP)
  endmacro (kid3_create_manpage)
endif (UNIX)

add_subdirectory(en)
add_subdirectory(de)

=== src/CMakeLists.txt ===
if (WITH_GCC_PCH)
  set(_headerFilename ${CMAKE_BINARY_DIR}/allsys.h)
  set(_gchFilename "${_headerFilename}.gch")

  if (NOT EXISTS ${_headerFilename})
    message(STATUS "Generating ${_headerFilename}")

    if (BUILD_KDE_APP)
      set(_includeRegex "#include <[Qkcp]")
    else (BUILD_KDE_APP)
      set(_includeRegex "#include <[Qcp]")
    endif (BUILD_KDE_APP)

    file(GLOB_RECURSE _srcList "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
                       "${CMAKE_CURRENT_SOURCE_DIR}/*.hpp"
                       "${CMAKE_CURRENT_SOURCE_DIR}/*.c"
                       "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
    set(_includes)
    foreach (_src ${_srcList})
      file(STRINGS ${_src} _inc REGEX ${_includeRegex})
      if (NOT "${_inc}" MATCHES "#include (.config\\.h.|.QAudio.*|.QMedia.*|.Qt?Plugin.*|.Qt?Test.*)")
        list(APPEND _includes ${_inc})
      endif()
    endforeach (_src ${_srcList})
    list(SORT _includes)
    list(REMOVE_DUPLICATES _includes)
    set(_txt "/* automatically generated */\n"
             "#ifndef ALLSYS_H\n"
             "#define ALLSYS_H\n"
             "#ifdef __cplusplus\n")
    foreach(_inc ${_includes})
      set(_txt "${_txt}${_inc}\n")
    endforeach(_inc _includes)
    set(_txt "${_txt}#endif\n#endif\n")
    file(WRITE ${_headerFilename} ${_txt})

    message(STATUS "Generating ${_gchFilename}")

    file(REMOVE ${_gchFilename})
    set(_additionalFlags "-DQT_CORE_LIB -DQT_DBUS_LIB -DQT_GUI_LIB -DQT_NETWORK_LIB -DQT_XML_LIB -Wundef -Wcast-align -Wall -W -Wpointer-arith  -fno-check-new -fno-common -Woverloaded-virtual -D_REENTRANT -DQT_NO_EXCEPTIONS -DQT_NO_STL -fvisibility=hidden -fvisibility-inlines-hidden -DQT_ASCII_CAST_WARNINGS -DQT_NO_CAST_TO_ASCII")
    if (CMAKE_BUILD_TYPE MATCHES Debug)
      set(_additionalFlags "${_additionalFlags} -g -DQT_DEBUG")
    else (CMAKE_BUILD_TYPE MATCHES Debug)
      set(_additionalFlags "${_additionalFlags} -O3 -DQT_NO_DEBUG -DNDEBUG")
    endif (CMAKE_BUILD_TYPE MATCHES Debug)
    list(APPEND _args -c ${_headerFilename} -o ${_gchFilename} ${_additionalFlags})
    get_directory_property(_dirinc INCLUDE_DIRECTORIES)
    foreach (_inc ${_dirinc})
      list(APPEND _args "-I" ${_inc})
    endforeach(_inc ${_dirinc})
    separate_arguments(_args)
    execute_process(
         COMMAND ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1} ${_args})
  endif (NOT EXISTS ${_headerFilename})

  set(GCC_PCH_COMPILE_FLAGS "-Winvalid-pch -include ${_headerFilename}")
endif (WITH_GCC_PCH)

set(PLUGIN_LIBRARIES)
add_subdirectory(plugins)
add_subdirectory(core)
add_subdirectory(gui)
add_subdirectory(app)

if (BUILD_TEST_APP)
  add_subdirectory(test)
endif (BUILD_TEST_APP)

=== src/app/CMakeLists.txt ===
include_directories(
  ../core/config
  ../core/utils
  ../core/tags
  ../core/model
  ../core/import
  ../gui/forms
  ../gui/dialogs
)

if (BUILD_CLI_APP)
  add_subdirectory(cli)
endif (BUILD_CLI_APP)

if (BUILD_QT_APP)
  add_subdirectory(qt)
endif (BUILD_QT_APP)

if (BUILD_KDE_APP)
  set(_cmakeInstallRpath "${CMAKE_INSTALL_RPATH}")
  find_package(KDE4 REQUIRED)
  include (KDE4Defaults)

  if (BUILD_SHARED_LIBS)
    # FindKDE4Internal.cmake will overwrite our RPATH if LIB_INSTALL_DIR (which
    # defaults to ${CMAKE_INSTALL_PREFIX}/lib) is not an implicit link directory.
    # In practice this means that most values for CMAKE_INSTALL_PREFIX other
    # than /usr will cause the RPATH to be overwritten and the kid3 executable
    # will not find its libraries. This happens also for the default value
    # /usr/local for CMAKE_INSTALL_PREFIX.
    # The RPATH is set again here to reverse this.
    set(_prefixLibdir "${CMAKE_INSTALL_PREFIX}/${WITH_LIBDIR}")
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${_prefixLibdir}" _isSystemDir)
    if ("${_isSystemDir}" STREQUAL "-1")
      list(APPEND _cmakeInstallRpath ${CMAKE_INSTALL_RPATH})
      list(REMOVE_DUPLICATES _cmakeInstallRpath)
      set(CMAKE_INSTALL_RPATH "${_cmakeInstallRpath}")
    endif ("${_isSystemDir}" STREQUAL "-1")
  endif (BUILD_SHARED_LIBS)

  add_subdirectory(kde)
  kde4_install_icons(${ICON_INSTALL_DIR})
endif (BUILD_KDE_APP)

=== src/app/kde/CMakeLists.txt ===
--- 
+++ 
@@ -15,4 +15,5 @@
 
 install(TARGETS kid3 DESTINATION ${BIN_INSTALL_DIR})
 install(FILES ../kid3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
+install(FILES ../kid3.appdata.xml DESTINATION "${WITH_DATAROOTDIR}/appdata")
 install(FILES kid3ui.rc DESTINATION ${DATA_INSTALL_DIR}/kid3)

=== src/app/qt/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
   mainqt.cpp
   platformtools.cpp
   kid3mainwindow.cpp
+  kid3qtapplication.cpp
   recentfilesmenu.cpp
   browserdialog.cpp
   messagedialog.cpp
@@ -12,6 +13,7 @@
 )
 set(qt_MOC_HDRS
   kid3mainwindow.h
+  kid3qtapplication.h
   recentfilesmenu.h
   browserdialog.h
   messagedialog.h
@@ -25,6 +27,7 @@
 if (APPLE)
   # Icon and properties for .plist file
   set(MACOSX_BUNDLE_BUNDLE_NAME "Kid3")
+  set(MACOSX_BUNDLE_BUNDLE_EXECUTABLE "kid3")
   set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
   set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
   set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
@@ -58,6 +61,14 @@
   add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
     DESTINATION "${WITH_DATAROOTDIR}/applications")
+  add_custom_command(OUTPUT kid3-qt.appdata.xml
+    COMMAND ${PERL_EXECUTABLE} -pe "s/kid3\\.desktop/kid3-qt.desktop/"
+      ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml >kid3-qt.appdata.xml
+    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml
+  )
+  add_custom_target("appdata-file" ALL DEPENDS kid3-qt.appdata.xml)
+  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.appdata.xml
+    DESTINATION "${WITH_DATAROOTDIR}/appdata")
   if (GZIP_PROGRAM)
     add_custom_command(OUTPUT kid3-qt.svg
       COMMAND ${GZIP_PROGRAM} -cd ${CMAKE_CURRENT_SOURCE_DIR}/../hisc-app-kid3.svgz >kid3-qt.svg

=== debian/changelog ===
kid3 (3.1.1-2) unstable; urgency=low

  * Add missing kid3-core manpages. Thanks to Achim Bohnet.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 13 Nov 2014 21:44:24 +0100

kid3 (3.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove deprecated hardening-wrapper package.
  * Remove versioned build dependency on libid3-3.8.3-dev and libflac++-dev.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 03 Sep 2014 10:41:21 +0200

=== debian/control ===
Source: kid3
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>,
 Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper (>= 9),
 libqt4-dev,
 kdelibs5-dev,
 cmake,
 libid3-3.8.3-dev,
 libflac++-dev,
 libvorbis-dev,
 libtag1-dev,
 libchromaprint-dev,
 libavformat-dev,
 libavcodec-dev,
 docbook-utils,
 pkg-config,
 libreadline-dev,
 xsltproc
Standards-Version: 3.9.5
Homepage: http://kid3.sourceforge.net/
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/kid3/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/kid3/

Package: kid3-core
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Audio tag editor core libraries and data
 An application to edit the ID3v1 and ID3v2 tags in MP3 files in an efficient
 way. These tags can be edited by most MP3 players, but not in a very
 comfortable and efficient way. Moreover the tags in Ogg/Vorbis, FLAC, MPC, APE,
 MP4/AAC, MP2, Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker
 modules (MOD, S3M, IT, XM) are supported too.
 .
 Features:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit Ogg/Vorbis tags
  * Edit FLAC tags
  * Edit APE tags in MPC files
  * Edit tags in MP3, Ogg/Vorbis, FLAC, MPC, MP4/AAC, MP2, Speex,
    TrueAudio and WavPack files
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs
  * Export tags as CSV, HTML, playlists, Kover XML and in other formats
 .
 This package contains common libraries and data used by kid3, kid3-qt and
 kid3-cli.

Package: kid3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: KDE MP3 ID3 tag editor
 An application to edit the ID3v1 and ID3v2 tags in MP3 files in an efficient
 way. These tags can be edited by most MP3 players, but not in a very
 comfortable and efficient way. Moreover the tags in Ogg/Vorbis, FLAC, MPC, APE,
 MP4/AAC, MP2, Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker
 modules (MOD, S3M, IT, XM) are supported too.
 .
 Features:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit Ogg/Vorbis tags
  * Edit FLAC tags
  * Edit APE tags in MPC files
  * Edit tags in MP3, Ogg/Vorbis, FLAC, MPC, MP4/AAC, MP2, Speex,
    TrueAudio and WavPack files
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs
  * Export tags as CSV, HTML, playlists, Kover XML and in other formats
 .
 This package uses KDE libraries, if you do not use KDE you should use kid3-qt.

Package: kid3-qt
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: Audio tag editor
 An application to edit the ID3v1 and ID3v2 tags in MP3 files in an efficient
 way. These tags can be edited by most MP3 players, but not in a very
 comfortable and efficient way. Moreover the tags in Ogg/Vorbis, FLAC, MPC, APE,
 MP4/AAC, MP2, Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker
 modules (MOD, S3M, IT, XM) are supported too.
 .
 Features:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit Ogg/Vorbis tags
  * Edit FLAC tags
  * Edit APE tags in MPC files
  * Edit tags in MP3, Ogg/Vorbis, FLAC, MPC, MP4/AAC, MP2, Speex,
    TrueAudio and WavPack files
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs
  * Export tags as CSV, HTML, playlists, Kover XML and in other formats
 .
 This package does not use KDE libraries, if you use KDE you should use kid3.

Package: kid3-cli
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Command line audio tag editor
 An application to edit the ID3v1 and ID3v2 tags in MP3 files in an efficient
 way. These tags can be edited by most MP3 players, but not in a very
 comfortable and efficient way. Moreover the tags in Ogg/Vorbis, FLAC, MPC, APE,
 MP4/AAC, MP2, Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker
 modules (MOD, S3M, IT, XM) are supported too.
 .
 Features:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit Ogg/Vorbis tags
  * Edit FLAC tags
  * Edit APE tags in MPC files
  * Edit tags in MP3, Ogg/Vorbis, FLAC, MPC, MP4/AAC, MP2, Speex,
    TrueAudio and WavPack files
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs
  * Export tags as CSV, HTML, playlists, Kover XML and in other formats
 .
 This package is supposed to be used on the command line.
